#include <stdio.h>
#include <stdlib.h>
#include "vahy_lib.h"

struct tuzel { 
  int prvek;
  struct tuzel *levy, *pravy;
  };
struct tseznam {
  struct tuzel *strom;
  struct tseznam *dalsi;
  };

struct tseznam *vytvor(int prvni, int posledni) {
  struct tseznam *vysledek, *seznam1, *seznam2, **ocas, *pomocna;
  if (prvni==posledni) {
    vysledek=malloc(sizeof(struct tseznam));
    vysledek->dalsi=NULL;
    vysledek->strom=malloc(sizeof(struct tuzel));
    vysledek->strom->prvek=prvni;
    vysledek->strom->levy=vysledek->strom->pravy=NULL;
    return vysledek;
    }
  seznam1=vytvor(prvni,(prvni+posledni)/2);
  seznam2=vytvor((prvni+posledni)/2+1,posledni);
  ocas=&vysledek;
  while (seznam1&&seznam2) {
    switch (porovnej(seznam1->strom->prvek,seznam2->strom->prvek)) {
    case 0:
      (*ocas)=malloc(sizeof(struct tseznam));
      (*ocas)->strom=malloc(sizeof(struct tuzel));
      (*ocas)->strom->prvek=seznam1->strom->prvek;
      (*ocas)->strom->levy=seznam1->strom;
      (*ocas)->strom->pravy=seznam2->strom;
      pomocna=seznam1; seznam1=seznam1->dalsi; free(pomocna);
      pomocna=seznam2; seznam2=seznam2->dalsi; free(pomocna);
      break;
    case -1:
      *ocas=seznam1; seznam1=seznam1->dalsi;
      break;
    case +1:
      *ocas=seznam2; seznam2=seznam2->dalsi;
      break;
      }
    ocas=&((*ocas)->dalsi);
    }
  *ocas=seznam1?seznam1:(seznam2?seznam2:NULL);
  return vysledek;
  }

void vypis_strom(FILE *soubor, struct tuzel *uzel) {
  if (uzel->levy) {
    vypis_strom(soubor,uzel->levy);
    vypis_strom(soubor,uzel->pravy);
    }
  else
    fprintf(soubor,"%d ",uzel->prvek);
  }  

void vypis_seznam(FILE *soubor, struct tseznam *seznam) {
  while (seznam) {
    vypis_strom(soubor, seznam->strom);
    fprintf(soubor,"\n");
    seznam=seznam->dalsi;
    }
  }

int main(void) {
  FILE *soubor;
  int N;
  struct tseznam *seznam;

  soubor=fopen("vahy.in","r");
  fscanf(soubor,"%d",&N);
  fclose(soubor);
  seznam=vytvor(1,N);
  soubor=fopen("vahy.out","w");
  vypis_seznam(soubor,seznam);
  fclose(soubor);
  return 0;
  }
